<?php

namespace Modules\Sc\Http\Controllers;

use Exception;
use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Modules\Hr\Entities\Employee;
use Modules\Hr\Entities\EmployeeDepartment;
use Modules\Pd\Entities\ScheduleCustomerOrderPlan;
use Modules\Pd\Entities\ScheduleCustomerOrderPlanData;
use Modules\Pd\Entities\ScheduleOrderResourceBom;
use Modules\PJ\Entities\Project;
use Modules\Pp\Entities\CustomerOrder;
use Modules\Pp\Entities\CustomerPlan;
use Modules\Pp\Entities\Machinary;
use Modules\Sc\Entities\MaterialRequestReason;
use Modules\Sc\Entities\MaterialRequisitionData;
use Modules\Sc\Entities\MaterialRequisitionDataOther;
use Modules\Sc\Entities\MaterialRequisitionHeader;
use Modules\Sc\Entities\StoreLocation;
use Modules\St\Entities\Product;
use Modules\St\Entities\ProductUnit;
use Modules\St\Entities\UnitOfMesurement;
use Modules\St\Entities\Uom;

class MaterialRequisitionController extends Controller
{
    public function allEmployees()
    {
        try {
            $employees = Employee::all();
            $result = array();
            foreach ($employees as $emp) {
                array_push($result, [
                    "img" => "",
                    "id" => $emp->employee_id,
                    "value" => $emp->name_withinitial,
                ]);
            }
            $responseBody = $this->responseBody(true, "MaterialRequisitionController", "allEmployees", $result);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MaterialRequisitionController", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }



    public function allProjects()
    {
        try {
            $projects = Project::all();
            $responseBody = $this->responseBody(true, "MaterialRequisitionController", "allProjects", $projects);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "GrnReturnController", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }




    public function allDepartment()
    {
        try {
            $department =  EmployeeDepartment::all();
            $responseBody = $this->responseBody(true, "MaterialRequisitionController", "allDepartment", $department);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MaterialRequisitionController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function allMachinery()
    {
        try {
            $machinery =  Machinary::all();
            $responseBody = $this->responseBody(true, "MaterialRequisitionController", "allMachinery", $machinery);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MaterialRequisitionController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function allMaterialRequestReason()
    {
        try {
            $reasons =  MaterialRequestReason::all();
            $responseBody = $this->responseBody(true, "MaterialRequisitionController", "allMaterialRequestReason", $reasons);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MaterialRequisitionController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function allProduct()
    {
        try {
            $products =  Product::select('product_primary_id As id', 'product_id As value0', 'product_name As value1')->get();
            return $this->responseBody(true, "MaterialRequisitionController", "allProduct", $products);
        } catch (Exception $exception) {
            return $this->responseBody(false, "MaterialRequisitionController", "error", $exception);
        }
    }


    public function maxID($store_id)
    {
        try {
            $id = DB::select('SELECT AUTO_INCREMENT  AS id FROM information_schema.TABLES WHERE TABLE_SCHEMA = "erp_riococo_salary3" AND TABLE_NAME = "sc_grn_headers"')[0]->id;
            $store = StoreLocation::find($store_id);
            $prefix = "";
            if ($store) {
                $prefix = $store->prefix;
            }
            $responseBody = $this->responseBody(true, "MaterialRequisitionController", "allProductUnit", ['id' => $id, 'prefix' => $prefix]);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MaterialRequisitionController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function allProductUnit()
    {
        try {
            $products =  ProductUnit::all();
            $responseBody = $this->responseBody(true, "MaterialRequisitionController", "allProductUnit", $products);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MaterialRequisitionController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }

    public function allStores()
    {
        try {
            $stores =  StoreLocation::all();
            $responseBody = $this->responseBody(true, "MaterialRequisitionController", "allStores", $stores);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MaterialRequisitionController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function allProductCustomer()
    {
        try {
            $orderPlan =  CustomerPlan::all();
            $responseBody = $this->responseBody(true, "MaterialRequisitionController", "allProductCustomer", $orderPlan);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MaterialRequisitionController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }




    public function save(Request $request)
    {
        try {
            $mrq = new MaterialRequisitionHeader();
            $mrq->external_id = $request->get('external_id');
            $mrq->ref_external_id = $request->get('ref_external_id');
            $mrq->trans_date = $request->get('trans_date');
            $mrq->dept_id = $request->get('dept_id');
            $mrq->machine_id = $request->get('machine_id');
            $mrq->store_id = $request->get('store_id');
            $mrq->supervisor_id = "0";
            $mrq->employee_name = $request->get('employee_name');
            $mrq->mi_type = $request->get('mi_type');
            $mrq->manufacturing_order_number = $request->get('manufacturing_order_number');
            $mrq->material_request_reason_id = $request->get('reason');
            $mrq->project_code = $request->get('project_code');
            $mrq->remarks = $request->get('remarks');
            $mrq->vehicle_no = $request->get('vehicle_no');
            $mrq->Status = 0;
            $mrq->user_id = Auth::user()->id;
            if ($mrq->save()) {
                /*$mrq_data = MaterialRequisitionData::find($mrq->internal_id);
                $mrq_data->ref_internal_id = $mrq_data->internal_id;
                $mrq_data->update();*/
                $mrq_arr = $request->get("mrq_data");
                for ($i = 0; $i < count($mrq_arr); $i++) {
                    $mrqData = json_decode($mrq_arr[$i]);
                    $mrq_data = new MaterialRequisitionData();
                    $mrq_data->internal_id = $mrq->internal_id;
                    $mrq_data->external_id = $mrq->external_id;
                    $mrq_data->product_id =  $mrqData->product_id;
                    $mrq_data->unit_id =  $mrqData->unit_id;
                    $mrq_data->quantity =  $mrqData->qty;
                    $mrq_data->transfer_quantity =  0;
                    $mrq_data->issues_quantity =  0;
                    $mrq_data->comments =  $mrqData->comments;
                    $mrq_data->save();
                }


                $purchase__other_arr = $request->get("request_other");
                for ($i = 0; $i < count($purchase__other_arr); $i++) {
                    $material_requisition_other = new MaterialRequisitionDataOther();
                    $material_requisition_other->internal_id = $mrq->internal_id;
                    $material_requisition_other->external_id = $mrq->external_id;
                    $material_requisition_other->description = $purchase__other_arr[$i]["description"];
                    $material_requisition_other->quantity = $purchase__other_arr[$i]["quantity"];
                    $material_requisition_other->save();
                }
            }
            $responseBody = $this->responseBody(true, "MaterialRequisitionController", "save", true);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "MaterialRequisitionController", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }






    public function getMaterialRequisition($id)
    {
        try {
            $mrq = MaterialRequisitionHeader::find($id);
            //$supervisor = Employee::find($mrq->supervisor_id);
            //$mrq->supervisor = $supervisor->name_withinitial;
            $received = Employee::find($mrq->received_by);

            $mi_data = MaterialRequisitionData::where('internal_id', '=', $id)->get();
            foreach ($mi_data as $data) {
                $product = Product::where('product_primary_id', '=', $data->product_id)->first();
                $data->product = $product->product_name;
                $uom = ProductUnit::find($product->uom_id);
                $uom_arr = [];
                if ($uom) {
                    array_push($uom_arr, ["value" => $uom->id, "text" => $uom->name]);
                }
                $data->uom = $uom_arr;
                $data->product_primary_id = $product->product_primary_id;
                $data->product_id = $product->product_id;
            }
            $mrq->data = $mi_data;
            $material_request_other = MaterialRequisitionDataOther::where('internal_id', '=', $id)->get();
            $mrq->request_other = $material_request_other;
            $responseBody = $this->responseBody(true, "MaterialRequisitionController", "getGrn", $mrq);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MaterialRequisitionController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function getQty($product_id, $store_id)
    {
        try {
            $query = "SELECT SUM(quantity) AS quantity FROM sc_product_histories WHERE product_id = '" . $product_id . "' AND store_id = '" . $store_id . "'";
            $result = DB::select($query);
            $quantity = 0;
            foreach ($result as $data) {
                if ($data->quantity) {
                    $quantity = $data->quantity;
                }
            }
            $responseBody = $this->responseBody(true, "MaterialRequisitionController", "getQty", $quantity);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MaterialRequisitionController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function update(Request $request, $id)
    {

        try {
            $mi_header = MaterialRequisitionHeader::find($id);
            if ($mi_header) {
                if ($this->delete($mi_header->external_id)) {
                    if ($mi_header->delete()) {
                        $bool =  $this->save($request);
                    }
                }
            }
            $responseBody = $this->responseBody(true, "MaterialRequisitionController", "update", $bool);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "MaterialRequisitionController", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }



    public function delete($id)
    {
        try {
            $mrq_data = MaterialRequisitionData::where('external_id', '=', $id)->get();
            foreach ($mrq_data as $data) {
                $data->delete();
            }
            $responseBody = $this->responseBody(true, "MaterialRequisitionController", "delete", true);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "MaterialRequisitionController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }




    public function getUom($id)
    {
        try {
            $product =  Product::where('product_primary_id', '=', $id)->first();

            $data = [
                "id" => "0",
                "value" => "",
            ];
            if ($product) {
                $uom =  ProductUnit::find($product->uom_id);
                if ($uom) {
                    $data["id"] = $uom->id;
                    $data["value"] = $uom->name;
                }
            }

            $responseBody = $this->responseBody(true, "PurchaseRequestController", "getUom", $data);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "PurchaseRequestController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function getScheduledFactoryPO()
    {
        try {
            $query = 'SELECT pp_customer_orders.order_id,
            pp_customer_orders.factory_po_num
            FROM pp_customer_orders
            INNER JOIN pd_schedule_customer_order_plans ON pp_customer_orders.order_id = pd_schedule_customer_order_plans.order_id';
            $data = DB::select($query);

            $responseBody = $this->responseBody(true, "PurchaseRequestController", "getScheduledFactoryPO", $data);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "PurchaseRequestController", "getScheduledFactoryPO", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function getProductFromOrder($id)
    {
        try {
            $query = 'SELECT
            st_products.product_primary_id,
            st_products.product_id,
            st_products.product_name
            FROM pd_schedule_customer_order_plans
            INNER JOIN pd_schedule_customer_order_plan_data ON pd_schedule_customer_order_plans.customer_order_plan_id=pd_schedule_customer_order_plan_data.customer_order_plan_id
            INNER JOIN st_products ON pd_schedule_customer_order_plan_data.product_id = st_products.product_primary_id WHERE pd_schedule_customer_order_plans.order_id = "' . $id . '"';
            $data = DB::select($query);

            $responseBody = $this->responseBody(true, "PurchaseRequestController", "getProductFromOrder", $data);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "PurchaseRequestController", "getProductFromOrder", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function getBomHeader($order_id, $product_primary_id)
    {
        try {

            $plan = CustomerOrder::find($order_id);
            $schedulePlan = ScheduleCustomerOrderPlan::where('order_id', '=', $order_id)->first();
            $bomData = [];
            $order_plan_data_id = '';
            if ($schedulePlan) {

                $plan_data = ScheduleCustomerOrderPlanData::where('customer_order_plan_id', '=', $schedulePlan->customer_order_plan_id)->first();
                if ($plan_data) {
                    $order_plan_data_id = $plan_data->customer_order_plan_data_id;
                    $bomData = $this->getBOMData($plan_data->customer_order_plan_data_id, $product_primary_id);
                }
            }

            $allocated_qty = $this->getAllocatedQuantity($order_id, $product_primary_id, '');
            $bom_header_qty = $this->getBomHeaderQuantityProduct($product_primary_id);

            $responseBody = $this->responseBody(true, "CustomerPlanData", "getSelectedProductData", ["allocated_quantity" => $allocated_qty, "bom_header_quantity" => $bom_header_qty, "customer_po" => $plan->purchase_order, "bom_data" =>  $bomData, "customer_order_plan_data_id" => $order_plan_data_id]);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "AllocateMachineController", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }





    public function setScheduleBom($order_plan_data_id, $fg_product_id)
    {
        try {

            $bomdata = $this->getBOMData($order_plan_data_id, $fg_product_id);
            foreach ($bomdata as $plan) {
                $plan->product_primary_id = "";
                $plan->product_id = "";
                $plan->product_name = "";
                //$plan->uom = [];
                $product = Product::find($plan->rm_product_id);
                if ($product) {
                    $plan->product_primary_id = $product->product_primary_id;
                    $plan->product_id = $product->product_id;
                    $plan->product_name = $product->product_name;
                }

                $uom = ProductUnit::find($plan->uom);
                $uom_arr = [];
                if ($uom) {
                    array_push($uom_arr, ["value" => $uom->id, "text" => $uom->name]);
                    $plan->uom = $uom_arr;
                }
            }
            $responseBody = $this->responseBody(true, "MaterialRequisitionController", "setScheduleBom", $bomdata);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "MaterialRequisitionController", "setScheduleBom", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }



    function getAllocatedQuantity($order_id, $product_id)
    {

        $plan = ScheduleCustomerOrderPlan::where('order_id', '=', $order_id)->first();

        $quantity = 0;

        if ($plan) {
            $plan_data = ScheduleCustomerOrderPlanData::where('customer_order_plan_id', '=', $plan->customer_order_plan_id)->first();
            if ($plan_data) {
                $query = 'SELECT SUM(pd_schedule_machinery_plans.quantity) AS quantity FROM pd_schedule_machinery_plans 
                WHERE pd_schedule_machinery_plans.customer_order_plan_data_id = "' . $plan_data->customer_order_plan_data_id . '" AND pd_schedule_machinery_plans.product_primary_id = "' . $product_id . '"';
                $result = DB::select($query);
                foreach ($result as $res) {
                    $quantity = $res->quantity;
                }
                if (!$quantity) {
                    $quantity = 0;
                }
            }
        }
        return $quantity;
    }



    function getBomHeaderQuantityProduct($product_id)
    {

        $quantity = 0;
        $query = 'SELECT pd_schedule_order_resource_boms.quantity FROM pd_schedule_order_resource_boms WHERE pd_schedule_order_resource_boms.rm_product_id = "' . $product_id . '"';
        $result = DB::select($query);
        foreach ($result as $res) {
            $quantity = $res->quantity;
        }
        if (!$quantity) {
            $quantity = 0;
        }
        return $quantity;
    }




    function getBOMData($customer_order_plan_data_id, $fg_product_id)
    {

        $query = 'SELECT st_product_units.name AS uom_name,
            st_products.product_primary_id,
            st_products.product_id,
            st_products.product_name,
            SUM(sc_product_histories.quantity) AS stock_in_h,
            pd_schedule_order_resource_boms.* 
            FROM pd_schedule_order_resource_boms
            INNER JOIN st_products ON pd_schedule_order_resource_boms.rm_product_id = st_products.product_primary_id
            INNER JOIN st_product_units ON pd_schedule_order_resource_boms.uom = st_product_units.id
            LEFT JOIN sc_product_histories ON pd_schedule_order_resource_boms.rm_product_id = sc_product_histories.product_id
            WHERE  pd_schedule_order_resource_boms.customer_order_plan_data_id = "' . $customer_order_plan_data_id . '" 
            AND pd_schedule_order_resource_boms.fg_product_id = "' . $fg_product_id . '" 
            GROUP BY pd_schedule_order_resource_boms.order_resource_bom_id';
        $result = DB::select($query);

        return $result;
    }



    /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
